4f9c968d7171770750aac64483a38f165f3a5d30
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.4
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # See the README file for information about the dependencies
19 # this script has.
20
21 ##############################################################################################
22 # Global Variables
23 ##############################################################################################
24 typeset cmd="$0 $*"
25 typeset dvdname=""
26 typeset debug=""
27 typeset dest=""
28 typeset isofile=""
29 typeset vobfile=""
30 typeset dvdpath=""
31 typeset aspect=""
32 typeset SCALE=""
33 typeset CROP=""
34 typeset profile="xvidhq"
35 typeset extension=""
36 typeset mailto=""
37 typeset encoder=""
38 typeset default_alang="en"
39 typeset track=""
40 typeset drc="0.0"
41 typeset -i default_aid=128
42 typeset -i aid_override=-1
43 typeset -i force_onepass_mode=0
44 typeset -i eject_disk=1
45 typeset -i keep_isofile=0
46 typeset -i keep_vobfile=0
47 typeset -i keep_dvdfolder=0
48 typeset -i keep_intermediate_files=0
49 typeset -i make_final_dest_vob=0
50 typeset -i make_final_dest_iso=0
51 typeset -i make_final_dest_folder=0
52 typeset -i make_final_dest_comp=0
53 typeset -i errors=0
54 typeset -i show_usage=0
55 typeset -i mirror_mode=0
56 typeset -i target_video_bitrate=2000
57 typeset -i target_audio_bitrate=224
58 typeset -i target_size=0
59 typeset -i audio_2ch=0
60 typeset -i audio_6ch=1
61 typeset -i invalid_feature_title=0
62 typeset -i feature_title_override=0
63 typeset -i mplayer_dumpstream_incompatibility=0
64 typeset -i custom_video_bitrate=0
65 typeset -i custom_audio_bitrate=0
66 typeset -i custom_audio_2ch=0
67 typeset -i custom_audio_6ch=0
68 typeset -i minimum_feature_title_length=10
69
70 ##############################################################################
71 # Local Machine Settings:
72 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
73 # and the local conf file created by each local machine (rip_dvd.conf)
74 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
75 # This will allow you to override all the default values to meet your needs
76 # in a way that won't get clobbered when you pull updates from my GIT repo.
77 ##############################################################################
78 config="${0%/*}/rip_dvd.conf"
79
80 # The config file will be searched for in the following location order:
81 found_config=0
82
83 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
84 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
85
86 # 2) /path/to/rip_dvd/script/rip_dvd.conf
87 [ -e "${config}" ] && found_config=1 && . "${config}"
88
89 # 3) /etc/rip_dvd.conf
90 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
91
92 # 4) $PWD/rip_dvd.conf
93 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
94
95 # Check to make sure we found the config file
96 if [ $found_config -eq 0 ]; then
97   echo "-E- Unable to find the rip_dvd.conf file: $config"
98   exit 1
99 fi
100
101 ##############################################################################################
102 # Command line processing
103 ##############################################################################################
104 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:B:s:t:a:p:e:j:l:r: opt "$@"
105 do
106     case $opt in
107         (n)     dvdname=$OPTARG;;
108         (d)     dest=$OPTARG;;
109         (b)     target_video_bitrate=$OPTARG; custom_video_bitrate=1;;
110         (B)     target_audio_bitrate=$OPTARG; custom_audio_bitrate=1;;
111         (s)     target_size=$OPTARG;;
112         (2)     audio_2ch=1; custom_audio_2ch=1;;
113         (6)     audio_6ch=1; custom_audio_6ch=1;;
114         (1)     force_onepass_mode=1;;
115         (v)     make_final_dest_vob=1;;
116         (i)     make_final_dest_iso=1;;
117         (f)     make_final_dest_folder=1;; 
118         (z)     make_final_dest_comp=1;;
119         (e)     encoder=$OPTARG;;
120         (m)     mirror_mode=1;;
121         (k)     keep_intermediate_files=1;;
122         (t)     feature_title_override=$OPTARG;;
123         (a)     aspect=$OPTARG;;
124         (p)     profile=$OPTARG;;
125         (x)     extension=$OPTARG;;
126         (j)     eject_disk=$OPTARG;;
127         (l)     aid_override=$OPTARG;;
128         (r)     drc=$OPTARG;;
129         (w)     set -x;;
130         (h)     show_usage=1;;
131         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
132         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
133     esac
134 done
135
136 shift $((OPTIND-1))
137
138 function usage() {
139     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
140     echo >&2 "Revision $REV"
141     echo >&2 "Options:"
142     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
143     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
144     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
145     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
146     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
147     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
148     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
149     echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
150     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
151     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
152     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
153     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
154     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
155     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
156     echo >&2 "                 Handbrake Only Encoder Profiles:"
157     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
158     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
159     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
160     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
161     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
162     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
163     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
164     echo >&2 "                 The default operation is non-mirror mode where only the main"
165     echo >&2 "                 feature title will be ripped."
166     echo >&2 "   -v            Make the final image a DVD VOB file"
167     echo >&2 "   -i            Make the final image a DVD ISO file"
168     echo >&2 "   -f            Make the final image a DVD folder"
169     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
170     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
171     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
172     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
173     echo >&2 "   -b <bitrate>  Set the video bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
174     echo >&2 "   -B <bitrate>  Set the audio bitrate desired in the compressed file in kbits/sec (ex: 96, 128, 160, 224 (default), 300, etc)"    
175     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
176     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
177     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
178     echo >&2 "   -j <n>        Eject the disk:"
179     echo >&2 "                 - 0 = do not eject the disk"
180     echo >&2 "                 - 1 = eject after the entire script is done (default)"
181     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
182     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
183     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
184     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
185     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
186     echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
187     echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
188     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
189     echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
190     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
191     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
192     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
193     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
194     echo >&2 ""
195     exit 2
196 }
197
198 if (($errors)) || (($show_usage))
199 then
200   usage
201 fi
202
203 # Sanity Check - Command Line Options 
204 if [ "$dest" == "" ]; then
205   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
206   usage
207 fi
208
209 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
210    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
211     # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
212     make_final_dest_comp=1
213 fi
214
215 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
216   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
217   usage
218 fi
219
220 if [ $target_video_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
221   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
222   usage
223 fi
224
225 if [ $mirror_mode -eq 1 ]; then
226   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
227      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
228     echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
229     usage
230   fi
231 fi
232
233 # Make handbrake the default encoder if not specified and we can find it
234 if [ -z "$encoder" ]; then
235   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
236   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
237   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
238   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
239   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
240 fi
241
242 # Sanity check the profile selection
243 if [[ "$encoder" == "mencoder" ]]; then
244   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
245 fi
246
247 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
248   echo "-E- Invalid encoder specified: $encoder"
249   exit 1
250 fi
251
252 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
253 if [ "$aspect" != "" ]; then
254   echo "$aspect" | grep -q "x"
255   if [ $? == 0 ]; then
256     echo "-E- You must specify the aspect option with a value whose format is W:H"
257     exit 1
258   fi
259   echo "$aspect" | grep -q ":"
260   if [ $? != 0 ]; then
261     [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
262     [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
263   else
264     [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
265     if [ "$encoder" == "handbrake" ]; then
266        WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
267        HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
268        SCALE="-w $WIDTH -l $HEIGHT"
269     fi
270   fi
271 fi
272
273 # Sanity Check - Key executables
274 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
275 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
276 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
277 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
278 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
279 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
280 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
281 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
282 [[ -n "$handbrake_xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing handbrake xvid encoder, set in rip_dvd.conf to: $handbrake_xvid" && exit
283 [[ -n "$handbrake_mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing handbrake mp4 encoder, set in rip_dvd.conf to: $handbrake_mp4" && exit
284 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
285 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
286 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
287 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
288 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
289
290 ##############################################################################################
291
292 typeset -i ripdvd
293 if [ -z "$dvdname" ]; then
294
295   # make sure the DVD device is accessible
296   volname $dev > /dev/null 2>&1
297   if [ $? != 0 ]; then
298     echo "-E- Can't access the DVD device $dev"
299     exit 1
300   fi
301   # now capture the volume name from the device
302   dvdname=`volname $dev | awk '{ print $1 }'`
303   ripdvd=1
304
305 else 
306
307   # check to see if dvdname is a full path to a real directory
308   # if it is, set dvdname and dvdpath appropriately
309   if [ -d "$dvdname" ]; then
310     dvdpath="$dvdname"
311     dvdname=`basename "$dvdname"`
312     keep_dvdfolder=1
313     if [ -z "$dvdname" ]; then
314      echo "-E- Unable to extract dvdname from path: $dvdpath"
315      exit 1
316     fi
317     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
318       echo "-E- You must supply a full path to a valid DVD folder with this option"
319       exit 1
320     fi
321   fi
322
323   # Check to see if dvdname is a full path to a file
324   if [ -f "$dvdname" ]; then
325     valid_file=0
326
327     # check to see if dvdname is a full path to an MPG2 (VOB) file
328     # if it is, set dvdname and vobfile appropriately
329     file "$dvdname" | grep -q "MPEG"
330     if [ $? == 0 ]; then
331       # It is a valid MPEG2 file, now strip the extension off our dvdname
332       vobfile="$dvdname"
333       dvdname=`basename "$dvdname"`
334       dvdname=${dvdname%.[^.]*}
335       keep_vobfile=1
336       valid_file=1
337     fi
338
339     # check to see if dvdname is a full path to an ISO file
340     # if it is, set dvdname and isofile appropriately
341     file "$dvdname" | grep -q -e "ISO" -e "UDF"
342     if [ $? == 0 ]; then
343       # It is a valid ISO file, now strip the extension off our dvdname
344       isofile="$dvdname"
345       dvdname=`basename "$dvdname"`
346       dvdname=${dvdname%.[^.]*}
347       keep_isofile=1
348       valid_file=1
349     fi    
350
351     # check to see if dvdname is a full path to an ISO file
352     # if it is, set dvdname and isofile appropriately
353     file "$dvdname" | grep -q -e "VOB"
354     if [ $? == 0 ]; then
355       # It is a valid VOB file, now strip the extension off our dvdname
356       vobfile="$dvdname"
357       dvdname=`basename "$dvdname"`
358       dvdname=${dvdname%.[^.]*}
359       keep_vobfile=1
360       valid_file=1
361     fi    
362
363     # If we didn't find a handler for the file above, complain
364     if [ $valid_file -eq 0 ]; then
365       echo "-E- Unsupported file type: $vobfile"
366       exit 1
367     fi
368
369   # Throw an error if we can't find what the -n option is pointing to
370   else 
371     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
372     exit 1
373   fi
374
375   # Set the ripdvd flag to false since we aren't ripping a DVD disk
376   ripdvd=0
377
378   # Since we aren't ripping a DVD disk, don't eject anything either
379   eject_disk=0
380
381 fi
382
383 # remove bad characters from the dvdname
384 dvdname=${dvdname%.} # remove trailing '.' character
385
386 # add the suffix extension to the end of the dvdname
387 dvdname=$dvdname$extension
388
389 # make a "safe" dvdname (remove special characters)
390 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
391
392 # Make sure we have a non-empty dvdname
393 if [ -z "$dvdname" ]; then
394   echo "-E- unable to determine dvdname"
395   exit 1
396 fi
397
398 # make sure our vobfile value is set
399 if [ -z "$vobfile" ]; then
400   vobfile="$dest/$dvdname.VOB"
401 fi
402
403 # set up some variables to hold various logfiles
404 logfile="$logdir/$dvdname.log"
405 passlogfile="$tmpdir/$safedvdname.log"
406 ddrescuelog=`tempfile`
407 dvdauthorlog=`tempfile`
408 encodelog=`tempfile`
409 dumplog=`tempfile`
410
411 # create the tmpdir if it doesn't already exist
412 if [ ! -d "$tmpdir" ]; then
413   mkdir -p "$tmpdir"
414   if [ $? != 0 ]; then
415     echo "-E- Unable to create the tmpdir: $tmpdir"
416     exit 1
417   fi
418 fi
419
420 # create the logdir if it doesn't already exist
421 if [ ! -d "$logdir" ]; then
422   mkdir -p "$logdir"
423   if [ $? != 0 ]; then
424     echo "-E- Unable to create the logdir: $logdir"
425     exit 1
426   fi
427 fi
428
429 ##############################################################################################
430 # cleanup functions
431 ##############################################################################################
432 cleanup() { 
433   if [ $keep_intermediate_files -eq 0 ]; then
434     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
435     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
436     [[ -e "$encodelog" ]] && rm -f "$encodelog"
437     [[ -e "$dumplog" ]] && rm -f "$dumplog"
438   else
439     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
440     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
441     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
442     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
443   fi
444   echo ""
445 }
446
447 fatal_and_exit() {
448   if [[ -z "$1" ]]; then
449     msg="-E- control-c killed us"
450   else
451     msg=$1
452   fi
453   echo -e 2>&1 "$msg" | tee -a "$logfile"
454   if [[ -n "$mailto" ]]; then
455     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
456   fi
457   keep_intermediate_files=1
458   exit 1
459 }
460
461 # Call our cleanup functions on INT and EXIT signals
462 trap fatal_and_exit INT
463 trap cleanup EXIT
464
465 ##############################################################################################
466 # processing functions
467 ##############################################################################################
468
469 # encode the vob file into a compressed file format using handbrake
470 function encode_vob_file_handbrake {
471   
472   # declare some globals
473   typeset handbrake_cli=""
474   typeset handbrake_video_encoder_opts=""
475   typeset filetype=""
476   typeset handbrake_audio_opts=""
477   typeset hb_profile=""
478   typeset SIZE=""
479   typeset AUDIO_BITRATE=""
480
481   # Set a variable that we will use later to determine if we found a handler for $profile or not
482   typeset -i found_profile=0    
483
484   # For a given profile, to override the 2 pass behavior to be single pass,
485   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
486   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
487   PASSES="-2"
488
489   # Set our DRC option
490   DRC="-D $drc"
491
492   if [ $target_size -ne 0 ]; then
493     SIZE="-S $target_size"
494   fi 
495
496   if [ $custom_audio_bitrate -eq 1 ]; then
497     AUDIO_BITRATE="-B $target_audio_bitrate"
498   fi
499
500   if [ $force_onepass_mode -eq 1 ]; then
501     PASSES=""
502   fi
503
504   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
505   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
506
507   # XVID profile
508   if [[ "$profile" =~ "xvid" ]]; then
509     found_profile=1
510     handbrake_cli="$handbrake_xvid"
511     final_output_file="$dest/$dvdname.avi"
512     filetype="avi"
513
514     # Very High Quality (16fps)
515     if [ "$profile" == "xvidvhq" ]; then
516       handbrake_opts[0]="-f avi"
517       handbrake_opts[1]="-b $target_video_bitrate"
518       handbrake_opts[2]="-e xvid"
519       handbrake_opts[3]="-T"
520       handbrake_opts[4]="-5"
521       handbrake_opts[5]="-8"
522     fi
523     # High Quality (20fps)
524     if [ "$profile" == "xvidhq" ]; then
525       handbrake_opts[0]="-f avi"
526       handbrake_opts[1]="-b $target_video_bitrate"
527       handbrake_opts[2]="-e ffmpeg"
528       handbrake_opts[3]="-T"
529       handbrake_opts[4]="-5"
530     fi
531     # Fast (28fps)
532     if [ "$profile" == "xvid" ]; then
533       handbrake_opts[0]="-f avi"
534       handbrake_opts[1]="-b $target_video_bitrate"
535       handbrake_opts[2]="-e ffmpeg"
536       handbrake_opts[3]="-T"
537     fi
538   fi
539
540   # MP4 profile
541   if [[ "$profile" =~ "mp4" ]]; then
542     found_profile=1
543     handbrake_cli="$handbrake_mp4"
544     final_output_file="$dest/$dvdname.mp4"
545     PASSES=""
546
547     # Handle custom parameter overrides
548     if [ $custom_video_bitrate == 1 ]; then
549       handbrake_opts[0]="-b $target_video_bitrate"
550     fi
551     if [ $custom_audio_2ch == 0 ]; then
552       audio_2ch=0
553     fi
554     if [ $custom_audio_6ch == 0 ]; then
555       audio_6ch=0
556     fi
557
558     # Very High Quality
559     if [ "$profile" == "mp4vhq" ]; then
560       profile="hb_High_Profile"
561     fi
562     # High Quality
563     if [ "$profile" == "mp4hq" ]; then
564       profile="hb_Normal"
565     fi
566     # Fast
567     if [ "$profile" == "mp4" ]; then
568       profile="hb_Classic"
569     fi
570   fi
571
572   # iphone and ipod MP4 profiles
573   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
574     found_profile=1
575     handbrake_cli="$handbrake_mp4"
576     final_output_file="$dest/$dvdname.mp4"
577     PASSES=""
578
579     # Handle custom parameter overrides
580     if [ $custom_video_bitrate == 1 ]; then
581       handbrake_opts[0]="-b $target_video_bitrate"
582     fi
583     if [ $custom_audio_2ch == 0 ]; then
584       audio_2ch=0
585     fi
586     if [ $custom_audio_6ch == 0 ]; then
587       audio_6ch=0
588     fi
589
590     # iphone
591     if [ "$profile" == "iphone" ]; then
592       profile="hb_iPhone_&_iPod_Touch"
593     fi
594     # ipod
595     if [ "$profile" == "ipod" ]; then
596       profile="hb_iPod"
597     fi
598
599   fi
600   
601   # Predefined Handbrake Profile Handling
602   if [[ "$profile" =~ "hb" ]]; then
603     found_profile=1
604     handbrake_cli="$handbrake_mp4"
605     final_output_file="$dest/$dvdname.mp4"
606     PASSES=""
607
608     # Handle custom parameter overrides
609     if [ $custom_video_bitrate == 1 ]; then
610       handbrake_opts[0]="-b $target_video_bitrate"
611     fi
612     if [ $custom_audio_2ch == 0 ]; then
613       audio_2ch=0
614     fi
615     if [ $custom_audio_6ch == 0 ]; then
616       audio_6ch=0
617     fi
618     
619     # extract the HandBrake Profile name from $profile
620     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
621   fi
622
623   # Make sure we found a handler for the given profile
624   if [ $found_profile -eq 0 ]; then
625     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
626   fi
627
628   # setup our audio option
629   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
630     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
631   fi
632   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
633     handbrake_audio_opts="-E ac3 -6 auto"
634   fi
635   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
636     handbrake_audio_opts="-E faac -6 dpl2"
637   fi
638   if [ -n "$track" ]; then
639     handbrake_audio_opts="$handbrake_audio_opts -a $track"
640   fi
641
642   # Convert our array of opts into a string
643   for OPTS in "${video_encoder_opts[@]}"; do 
644     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
645   done
646   if [ -n "$handbrake_video_encoder_opts" ]; then
647     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
648   fi
649   for OPTS in "${handbrake_opts[@]}"; do 
650     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
651   done
652
653   # Append "global" command line options
654   handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
655   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
656   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
657   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
658   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
659   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $AUDIO_BITRATE"
660
661   # Execute the handbrake command to encode the video
662   # I have to copy-n-paste the code below to handle the 2 conditions, 1) hb_profile (mp4) 2) no hb_profile (xvid)
663   # The problem is the -Z "$hb_profile" option. I have to quote the "$hb_profile" due to spaces in it, forcing me to call it out explicity.
664   if [ -n "$hb_profile" ]; then
665     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
666     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
667     handbrake_retval=$?
668   else 
669     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
670     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
671     handbrake_retval=$?
672   fi
673   if [ $handbrake_retval != 0 ]; then
674     fatal_and_exit "-E- Unhandled handbrake error"
675   fi
676
677   # Concatenate the encode log to our main log file, greping out unwanted lines
678   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
679   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
680   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
681 }
682
683 # encode the vob file into a compressed file format using mencoder
684 function encode_vob_file_mencoder {
685
686   # Set a variable that we will use later to determine if we found a handler for $profile or not
687   typeset -i found_profile=0
688
689   # For a given profile, to override the 2 pass behavior to be single pass,
690   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
691   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
692   PASSES="1 2"
693
694   # Declare our default 2 pass variables
695   passlogfile_opt="-passlogfile $passlogfile"
696   pass_opt="pass=%PASS"
697
698   # Check the global force_onepass_mode. If it is set, change our variables appropriately
699   # to force 1-pass encoding across all profiles.
700   if [ $force_onepass_mode -eq 1 ]; then
701     PASSES="2"
702     passlogfile_opt=""
703     pass_opt=""    
704   fi
705
706   # XVID profile
707   if [[ "$profile" =~ "xvid" ]]; then
708     found_profile=1
709     final_output_file="$dest/$dvdname.avi"
710     mencoder_general_opts="$lang_opts $passlogfile_opt"
711     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
712     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
713     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
714
715     # Very High Quality (16fps)
716     if [ "$profile" == "xvidvhq" ]; then
717       video_encoder_opts[0]="bitrate=$target_video_bitrate"
718       video_encoder_opts[1]="threads=$mencoder_threads"
719       video_encoder_opts[2]="chroma_opt"
720       video_encoder_opts[3]="vhq=4"
721       video_encoder_opts[4]="bvhq=1"
722       video_encoder_opts[5]="quant_type=mpeg"
723       video_encoder_opts[6]="autoaspect"
724     fi
725     # High Quality (20fps)
726     if [ "$profile" == "xvidhq" ]; then
727       video_encoder_opts[0]="bitrate=$target_video_bitrate"
728       video_encoder_opts[1]="threads=$mencoder_threads"
729       video_encoder_opts[2]="chroma_opt"
730       video_encoder_opts[3]="vhq=2"
731       video_encoder_opts[4]="bvhq=1"
732       video_encoder_opts[5]="quant_type=mpeg"
733       video_encoder_opts[6]="autoaspect"
734     fi
735     # Fast (28fps)
736     if [ "$profile" == "xvid" ]; then
737       video_encoder_opts[0]="bitrate=$target_video_bitrate"
738       video_encoder_opts[1]="threads=$mencoder_threads"
739       video_encoder_opts[2]="vhq=0"
740       video_encoder_opts[3]="turbo"
741       video_encoder_opts[4]="autoaspect"
742     fi
743
744     for OPTS in "${video_encoder_opts[@]}"; do 
745       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
746     done
747
748     if [ $audio_2ch -eq 0 ]; then
749       # These options produce good 6 channel audio for linux and windows
750       mencoder_audio_opts="-oac copy"
751       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
752       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
753       mencoder_audioch_opts[1]="-af channels=6"
754       mencoder_audioch_opts[2]=""
755     else
756       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
757       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$target_audio_bitrate"
758       mencoder_audioch_opts[0]=""
759     fi
760  
761   fi
762
763   # iphone and ipod MP4 profiles
764   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
765     found_profile=1
766     if [ "$profile" == "iphone" ]; then
767       # SCALE: 480x320
768       # scale width to 480, set height appropriately, but keep a multiple of 16
769       #SCALE=",scale=480:-10"
770       # scale the video down however far is necessary to fit in 480x320
771       SCALE=",dsize=480:320:0,scale=-8:-8"
772     else
773       # SCALE: 320x240
774       # scale width to 320, set height appropriately, but keep a multiple of 16
775       #SCALE=",scale=320:-10"
776       # scale the video down however far is necessary to fit in 320x240
777       SCALE=",dsize=320:240:0,scale=-8:-8"
778     fi
779     final_output_file="$dest/$dvdname.mp4"
780     mencoder_general_opts="$lang_opts $passlogfile_opt"
781     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
782     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
783     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
784     video_encoder_opts[0]="bitrate=$target_video_bitrate"
785     video_encoder_opts[1]="threads=$mencoder_threads"
786     video_encoder_opts[2]="vbv_maxrate=1500"
787     video_encoder_opts[3]="vbv_bufsize=2000"
788     video_encoder_opts[4]="nocabac"
789     video_encoder_opts[5]="me=umh"
790     video_encoder_opts[6]="subq=6"
791     video_encoder_opts[7]="frameref=6"
792     video_encoder_opts[8]="trellis=1"
793     video_encoder_opts[9]="level_idc=30"
794     video_encoder_opts[10]="global_header"
795     video_encoder_opts[11]="bframes=0"
796     video_encoder_opts[12]="partitions=all"
797     for OPTS in "${video_encoder_opts[@]}"; do 
798       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
799     done
800
801     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$target_audio_bitrate:raw"
802     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
803   fi
804
805   if [ $found_profile -eq 0 ]; then
806     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
807   fi
808
809   # Do not edit this line. $mencoder_video_encoder_opts must be last
810   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
811   mencoder_retval=0
812
813   for PASS in $PASSES
814   do 
815     # Set some options based on which pass we are in
816     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
817     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
818     [ $PASS -eq 1 ] && output_file="/dev/null"
819     [ $PASS -eq 2 ] && output_file="$final_output_file"
820   
821     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
822     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
823     do
824       echo -e "   Encoding pass $PASS"
825       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
826       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
827       mencoder_retval=$? 
828       grep -q "\[channels\] Invalid" $encodelog
829       if [ $? != 0 ]; then          
830         break;
831       else
832         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
833       fi
834     done
835       
836     if [ $mencoder_retval != 0 ]; then
837       fatal_and_exit "-E- Unhandled mencoder error"
838     fi
839
840     # Concatenate the encode log to our main log file, greping out unwanted lines
841     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
842
843   done
844 }
845
846 function make_dvd_iso_image {
847
848   isofile="$1"
849
850   # check to see if we have a dvdpath to rip from instead of $dev
851   if [ -z "$dvdpath" ]; then
852     # load the CSS codes in the DVD drive 
853     lsdvd $dev >> "$logfile"
854     if [ $? != 0 ]; then
855       fatal_and_exit "-E- lsdvd $dev failed" 
856     fi
857
858     # read the DVD, ignoring/skipping CRC errors
859     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
860     if [ $? != 0 ]; then
861       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
862     fi
863     cat "$ddrescuelog" >> "$logfile"
864   else
865     # rip from a path instead
866     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
867   fi
868 }
869
870 function make_dvd_iso_image_from_folder {
871   
872   src="$1"
873   dst="$2"
874   handle_error=$3
875   
876   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
877
878   # make an iso image out of our directory
879   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
880   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
881
882   # set the audio languages from the iso if it exists and is non-zero in size
883   if [ -s "$dst" ]; then
884     get_feature_title "$dst"
885     get_audio_id_from_iso "$dst"
886   fi
887
888   # make sure we were able to create the iso image from the folder given to us
889   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
890     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
891     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
892     # remove the bad iso file
893     [[ -e "$dst" ]] && rm -f "$dst"
894     # get the feature title from the DVD folder
895     get_feature_title "$dvdpath"
896     # create our main VOB file from the ISO
897     create_main_vob_with_mplayer "$dvdpath" 
898     # get our audio id from the VOB file
899     get_audio_id_from_vob "$vobfile"
900   fi
901 }
902
903 function make_dvdbackup_folder_image {
904   # extract the feature title from the DVD image
905   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
906   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
907   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
908   if [ $? != 0 ]; then
909     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
910   fi
911 }
912
913 function make_dvdauthor_folder_image {
914   # create a new DVD video of the feature title
915   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
916   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
917   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
918   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
919
920   # There is a chance that dvdauthor won't like some of the VOBs.
921   # We can't tell ahead of time which ones it will choke on. 
922   # So, we need to run it over and over again until it can process
923   # all the VOBs. If it can't handle one of them, run it through
924   # mencoder to fix it and try again. These errors are typically
925   # present due to the copy protection that ddrescue removed.
926   grep -q "SCR moves" $dvdauthorlog
927   while [ $? == 0 ]; do
928     # fix bad vobs that get the "SCR moves backwards" error:
929     #  STAT: Processing VTS_01_0.VOB...
930     #  ERR:  SCR moves backwards, remultiplex input.
931     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
932     if [[ ! -f "$badvob" ]]; then
933       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
934     fi
935     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
936     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
937     mv -f $badvob.fixed $badvob
938     echo "-> Creating DVD video $dest/$dvdname"
939     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
940     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
941     grep -q "SCR moves" $dvdauthorlog
942   done
943 }
944
945 function get_feature_title {
946   source="$1"
947   # if a feature title was given on the command line, use it
948   if [ $feature_title_override -ne 0 ]; then
949     feature_title=$feature_title_override
950     return 0
951   fi
952   # otherwise, use lsdvd to figure it out
953   if [ $ripdvd -eq 1 ]; then
954     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
955   else 
956     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
957   fi
958 }
959
960 function create_main_vob_with_cat {
961   # cd to the feature title DVD folder
962   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
963   if [ $? != 0 ]; then
964     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
965   fi
966
967   # concatenate all the VOBs together into 1 giant VOB
968   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
969   cat $vobs > "$tmpdir/$dvdname.VOB"
970
971   # cd back to the dir we started from
972   popd > /dev/null 2>&1
973 }
974
975 function create_main_vob_with_mplayer {
976
977   # argument processing  
978   source="$1"
979   remove_dumplog=$2
980
981   # make sure we have a valid feature title
982   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
983     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
984   fi
985
986   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
987   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
988     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
989     msg="$msg We also detected a condition that may require you to use dumpstream. "
990     msg="$msg\n    Unable to rip this DVD in the mode you requested."
991     fatal_and_exit "$msg"
992   fi
993
994   # use mplayer to create the main VOB file
995   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
996   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
997   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
998   if [ $? != 0 ]; then
999     cat $dumplog | grep -v "^A:" >> "$logfile"
1000     fatal_and_exit "-E- Mplayer Failed"
1001   fi
1002   cat $dumplog | grep -v "^A:" >> "$logfile"
1003   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
1004 }
1005
1006 function get_audio_id_from_iso {
1007   # Adjust our audio ID to find the english audio stream
1008   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1009   iso="$1"
1010   aidcheck=`tempfile`
1011   aid=$default_aid
1012   alang=$default_alang
1013   if [ $aid_override -lt 0 ]; then 
1014     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
1015     grep -q "aid: $aid" $aidcheck
1016     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1017       (( aid = aid + 1 ))
1018       grep -q "aid: $aid" $aidcheck
1019     done
1020     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1021   else
1022     aid=$aid_override
1023   fi
1024   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1025   # mencoder default DVD audio track language selection (english)
1026   lang_opts="-aid $aid -alang $alang"
1027 }
1028
1029 function get_crop_from_iso { 
1030   FRAMES=10000
1031   echo "-> Detecting black frame border crop value from ISO file"
1032   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
1033   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
1034   [[ -e "md5sums" ]] && rm -f "md5sums"
1035   CROP=`cat $dumplog | grep CROP | tail -1`
1036   echo "   Found crop value of $CROP" >> "$logfile"
1037   CROP=${CROP#* crop=}
1038   CROP=${CROP%%\).*}
1039   typeset -i CROPCHECK
1040   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1041   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1042   if [ -z "$CROP" ]; then
1043     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1044     return
1045   fi
1046   if [ $CROPCHECK -lt 0 ]; then 
1047     CROP=""
1048   else 
1049     CROP=",crop=$CROP"
1050   fi
1051   echo "   Setting mencoder crop filter to: $CROP"
1052 }
1053
1054 function get_crop_from_vob { 
1055   FRAMES=10000
1056   echo "-> Detecting black frame border crop value from VOB file"
1057   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
1058   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
1059   [[ -e "md5sums" ]] && rm -f "md5sums"
1060   CROP=`cat $dumplog | grep CROP | tail -1`
1061   echo "   Found crop value of $CROP" >> "$logfile"
1062   CROP=${CROP#* crop=}
1063   CROP=${CROP%%\).*}
1064   typeset -i CROPCHECK
1065   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1066   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1067   if [ -z "$CROP" ]; then
1068     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1069     return
1070   fi
1071   if [ $CROPCHECK -lt 0 ]; then 
1072     CROP=""
1073   else 
1074     CROP=",crop=$CROP"
1075   fi
1076   echo "   Setting mencoder crop filter to: $CROP"
1077 }
1078
1079 function get_audio_track_from_vob {
1080   # Adjust our audio ID to find the english audio stream
1081   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1082   vob="$1"
1083   handbrake_cli="$2"
1084   aidcheck=`tempfile`
1085   aid=$default_aid
1086   alang=$default_alang
1087   if [ $aid_override -lt 0 ]; then 
1088     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1089     grep -q "Found audio stream: $aid" $aidcheck
1090     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1091       (( aid = aid + 1 ))
1092       grep -q "Found audio stream: $aid" $aidcheck
1093     done
1094     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1095   else 
1096     aid=$aid_override
1097   fi
1098   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1099
1100   # convert the aid we found into hex
1101   aid_hex=`echo "obase=16; $aid" | bc`
1102   
1103   # extract the audio streams in the vob
1104   #ffmpeg -i "$vob" > $aidcheck 2>&1
1105   $handbrake_cli --stop-at duration:1 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1106   
1107   # find the stream that matches our aid
1108   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1109   #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1110   stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
1111  
1112   # extract the track number that handbrake uses
1113   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1114   track=`expr match "$stream" '^\([0-9]*\):'`
1115
1116   if [ -n "$track" ]; then   
1117     echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1118   fi
1119 }
1120
1121 function get_audio_id_from_vob {
1122   # Adjust our audio ID to find the english audio stream
1123   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1124   vob="$1"
1125   aidcheck=`tempfile`
1126   aid=$default_aid
1127   alang=$default_alang
1128   if [ $aid_override -lt 0 ]; then 
1129     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1130     grep -q "Found audio stream: $aid" $aidcheck
1131     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1132       (( aid = aid + 1 ))
1133       grep -q "Found audio stream: $aid" $aidcheck
1134     done
1135     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1136   else 
1137     aid=$aid_override
1138   fi
1139   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1140   # mencoder default DVD audio track language selection (english)
1141   lang_opts="-aid $aid -alang $alang"
1142 }
1143
1144 function check_vob_for_corrupted_start {
1145   # check to see if the beginning of the DVD has a form of copy protection
1146   # where they have deliberately broken the first X number of frames of the DVD.
1147   # If we don't skip these, our resulting VOB file will not play.
1148   badvobcheck=`tempfile`
1149   endpos=360
1150   skip=0
1151   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1152   if [ $? != 0 ]; then
1153     fatal_and_exit "-E- Mencoder Failed"
1154   fi
1155   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1156   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1157     (( skip = skip + 5 ))
1158     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1159     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1160     if [ $? != 0 ]; then
1161       fatal_and_exit "-E- Mencoder Failed"
1162     fi
1163     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1164   done
1165   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1166
1167   # cat the giant VOB into mencoder to create a playable VOB file
1168   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1169   if [ $? != 0 ]; then
1170     fatal_and_exit "-E- Mencoder Failed"
1171   fi
1172 }
1173
1174 function check_vob_for_completeness {
1175   # check to make sure we got out a complete VOB.
1176   # there is another kind of copy protection where the VOB's may
1177   # have "MPG EOF" frames in the middle of the stream. 
1178   # this causes mencoder to not process the entire VOB, and exit without any errors.
1179   # detect this by seeing how much smaller the dst vob is from the src vob.
1180   MAX_FILESIZE_DELTA_PERCENT=70
1181   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1182   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1183   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1184   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1185     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1186     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1187     create_main_vob_with_mplayer "$isofile"
1188     [[ -e "$dumplog" ]] && rm -f $dumplog
1189     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1190     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1191     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1192       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1193     fi
1194   fi
1195 }
1196
1197 function check_vob_for_too_many_video_packets {
1198   # If our earlier algorithm to work around this failed, throw an error.
1199   # check to see if this DVD has a protection scheme we don't know how to work around
1200   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1201   # for some reason, the video is black, while the audio rolls, then the video finally comes
1202   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1203   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1204   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1205   grep -q "Too many video packets in the buffer:" "$logfile"
1206   if [ $? == 0 ]; then
1207     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1208     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1209     create_main_vob_with_mplayer "$isofile"
1210     grep -q "Too many video packets in the buffer:" $dumplog
1211     if [ $? == 0 ]; then
1212       [[ -e "$dumplog" ]] && rm -f $dumplog
1213       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1214     fi
1215     [[ -e "$dumplog" ]] && rm -f $dumplog
1216   fi
1217 }
1218
1219 function check_vob_for_a52_crc_errors {
1220   # Let's see if we can playback our newly created VOB file without any errors.
1221   # if there are issues, let's detect them now, and try to recreate the VOB
1222   # there are some forms of copy protection that have missed above, that evidence
1223   # themselves when we try to playback the VOB file. This was added to deal with
1224   # the "a52: CRC check failed" copy protection scheme.
1225   MAX_ERRORS=10
1226   ENDPOS=120
1227   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1228   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1229   cat $dumplog | grep -v "^A:" >> "$logfile"
1230   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1231   if [ $errors -gt $MAX_ERRORS ]; then
1232     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1233     create_main_vob_with_mplayer "$isofile"
1234     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1235     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1236     if [ $? != 0 ]; then
1237       cat $dumplog | grep -v "^A:" >> "$logfile"
1238       fatal_and_exit "-E- Mplayer Failed"
1239     fi
1240     cat $dumplog | grep -v "^A:" >> "$logfile"
1241     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1242     if [ $errors -gt $MAX_ERRORS ]; then
1243       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1244     fi
1245   fi
1246   [[ -e "$dumplog" ]] && rm -f $dumplog
1247 }
1248
1249 function calculate_bitrate_from_target_size {
1250   # determine what our bitrate needs to be if a target size was specified instead
1251   if [ $target_size -ne 0 ] && [ $custom_video_bitrate -eq 0 ]; then
1252     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1253     ((min_length = minimum_feature_title_length * 60))
1254     if [[ $vob_length -gt $min_length ]]; then 
1255       ((target_video_bitrate = (target_size * 1024 * 8) / vob_length ))
1256       custom_video_bitrate=1
1257       echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_video_bitrate kbits/sec" | tee -a "$logfile"
1258     else
1259       echo "-W- Unable to determine the real length of this DVD feature title." | tee -a "$logfile"
1260       echo "    A target bitrate from the target_size requested will not be set." | tee -a "$logfile"
1261       echo "    If using handbrake, only the target_size will be passed to the encoder." | tee -a "$logfile" 
1262       echo "    If using mencoder, the target_size will be entirely disregarded." | tee -a "$logfile"
1263       echo "    You may need to rerun with the -b option with a target bitrate to get the desired size." | tee -a "$logfile"
1264       if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
1265         fatal_and_exit "-E- You'll need rip this DVD with the handbrake encoder and an MP4 type profile to get a good rip."
1266       fi
1267     fi
1268   fi
1269 }
1270
1271 function create_dvdauthor_dvd_xml_file {
1272   # make a dvdauthor xml menu file to create a valid DVD video from 
1273   # this script does a good job, but we'll still need to clean it up a bit after it runs
1274   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1275   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1276   if [ $? != 0 ]; then
1277     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1278   fi
1279
1280   # replace the first line of the xml file to remove the bad dest path
1281   awk -v line=1 -v new_content="<dvdauthor>" '{
1282     if (NR == line) {
1283       print new_content;
1284     } else {
1285       print $0;
1286     }
1287   }' dvd.xml > dvd.xml.new
1288   mv -f dvd.xml.new dvd.xml
1289   if [ $? != 0 ]; then
1290     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1291   fi
1292
1293   # remove the "<video " property line from the xml file
1294   cat dvd.xml | grep -v "<video" > dvd.xml.new
1295   mv -f dvd.xml.new dvd.xml
1296   if [ $? != 0 ]; then
1297     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1298   fi
1299   
1300   # remove the extra <pgc>..</pgc> pairs
1301   cat dvd.xml | awk 'BEGIN {x=1}
1302   {
1303     if ($0~"</pgc>") {x=0}
1304     if (x==1) {print $0}
1305     if ($0~"<pgc>") {x=1}
1306   }' > dvd.xml.new
1307   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1308   mv -f dvd.xml.new dvd.xml
1309   if [ $? != 0 ]; then
1310     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1311   fi
1312
1313   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1314   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1315   mv -f dvd.xml.new dvd.xml
1316   if [ $? != 0 ]; then
1317     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1318   fi
1319 }
1320
1321 function check_for_mplayer_dumpstream_incompatibility {
1322
1323   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1324
1325   if [ ! -e "$vobfile" ]; then
1326     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1327     # A DVD that has 99 titles, where the longest title isn't the main feature
1328     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1329     # out what the feature title is. This script will run through that flow if we
1330     # set use_mplayer_dumpstream to 0. Check for this here.
1331     if [ $ripdvd -eq 1 ]; then
1332       lsdvd $dev | grep -q "Title: 99"
1333     else
1334       lsdvd "$isofile" | grep -q "Title: 99"
1335     fi
1336     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1337     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1338       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1339         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1340         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1341         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1342         invalid_feature_title=1
1343       else 
1344         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1345         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1346         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1347         use_mplayer_dumpstream=0
1348         invalid_feature_title=1
1349       fi
1350       return
1351     fi
1352   fi
1353
1354   # There is another form of protection that causes the mplayer dumpstream to fail. 
1355   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1356   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1357   # problem before continuing.
1358   if [ -e "$vobfile" ]; then
1359     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1360     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1361     grep -q "Too many audio packets in the buffer" $dumplog
1362     if [ $? == 0 ]; then
1363       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1364       use_mplayer_dumpstream=0
1365       mplayer_dumpstream_incompatibility=1
1366     fi
1367     [[ -e "$dumplog" ]] && rm -f $dumplog
1368   fi
1369
1370   # There is another form of protection that causes the mplayer dumpstream to fail.
1371   # The resulting VOB file looks complete, but has something in it that causes mplayer/mencoder 
1372   # to be unable to encode it since it thinks the entire VOB is only a few minutes long in length.
1373   # Using HandBrake with an MP4 type profile can work around this, but mencoder or Handbrake with XVID profile won't.
1374   vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1375   ((min_length = minimum_feature_title_length * 60))
1376   if [[ $vob_length -lt $min_length ]]; then 
1377     if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
1378       echo "-E- The main feature title that was ripped from the DVD has an invalid movie length." | tee -a "$logfile"
1379       echo "    You'll need rip this DVD with the handbrake encoder and an MP4 type profile instead." | tee -a "$logfile"
1380       mplayer_dumpstream_incompatibility=1
1381     fi
1382   fi
1383 }
1384
1385 function fill_mythvideo_metadata {
1386
1387   # This function must be passed the filename as an argument
1388   # The filename must be a full path to the file
1389   filename="$1"
1390
1391   # Make sure the fill mythvideo metadata option has been set to 1
1392   if [ $fill_mythvideo_metadata -eq 0 ]; then
1393     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1394     return 0
1395   fi
1396
1397   # If the fill mythvideo metadata script is present, run it
1398   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1399   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1400     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1401     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1402   else
1403     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1404     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1405   fi
1406 }
1407
1408 # remove the intermediate VOB file
1409 function remove_intermediate_vob_file {
1410   if [ $keep_intermediate_files -eq 0 ]; then
1411     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1412   else
1413     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1414   fi
1415 }
1416
1417 # remove the original DVD image 
1418 function remove_intermediate_iso_file {
1419   [[ $keep_isofile -eq 1 ]] && return 1
1420   if [ $keep_intermediate_files -eq 0 ]; then
1421     [[ -e "$isofile" ]] && rm "$isofile"
1422   else
1423     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1424   fi
1425 }
1426
1427 # remove the intermediate dvdbackup folder
1428 function remove_intermediate_dvdbackup_folder {
1429   if [ $keep_intermediate_files -eq 0 ]; then
1430     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1431   else
1432     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1433   fi
1434 }
1435
1436 ##############################################################################################
1437 # MAIN
1438 ##############################################################################################
1439
1440 # Make a note of when this DVD rip started
1441 date=`date`
1442 echo -e "\n$date DVD rip started" >> "$logfile"
1443 echo "$cmd" >> "$logfile"
1444
1445 # Rip the DVD - Mirror Mode
1446 if [ $mirror_mode -eq 1 ]; then
1447   echo "-> Ripping DVD $dvdname to $dest"
1448
1449   # use ddrescue to make an ISO image of the disk
1450   make_dvd_iso_image "$dest/$dvdname.iso"
1451
1452   # add this video data to the mythtv DB
1453   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1454
1455   # eject the disk upon completion
1456   if [ $eject_disk -ne 0 ]; then
1457     eject -T $dev
1458   fi
1459
1460   date=`date`
1461   echo "$date DVD rip completed" | tee -a "$logfile"
1462
1463   if [[ -n "$mailto" ]]; then
1464     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1465   fi
1466
1467 fi
1468
1469 # Rip the DVD - Main Title Feature Only
1470 if [ $mirror_mode -eq 0 ]; then
1471
1472   # Rip image from DVD
1473   if [ $ripdvd -eq 1 ]; then
1474     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1475     # use ddrescue to make an ISO image of the disk
1476     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1477   fi
1478
1479   # Rip image from DVD path
1480   if [ -n "$dvdpath" ]; then
1481     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1482     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1483   fi
1484
1485   # make sure our isofile value is set
1486   if [ -z "$isofile" ]; then
1487     isofile="$tmpdir/$dvdname.iso"
1488   fi
1489      
1490   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1491
1492     if [ ! -e "$vobfile" ]; then
1493       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1494       
1495       # get the feature title from the ISO
1496       get_feature_title "$isofile"
1497  
1498       # get the crop value from the ISO
1499       get_crop_from_iso
1500
1501       # check for mplayer dumpstream incompatibilities
1502       # if they exist, this method will set this mode to 0.
1503       check_for_mplayer_dumpstream_incompatibility
1504
1505       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1506
1507         # get our audio id from the ISO file
1508         get_audio_id_from_iso "$isofile"
1509
1510         # create our main VOB file from the ISO
1511         create_main_vob_with_mplayer "$isofile"
1512      
1513         # remove the intermediate VOB file
1514         remove_intermediate_vob_file
1515
1516         # it's possible that our VOB is still corrupted in some manner
1517         # check to make sure it is still a good VOB before continuing.
1518         check_for_mplayer_dumpstream_incompatibility
1519
1520       fi
1521  
1522       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1523
1524         # use dvdbackup to make a DVD folder of the feature title
1525         make_dvdbackup_folder_image
1526   
1527         # create our main VOB file
1528         create_main_vob_with_cat
1529
1530         # get our audio id from the VOB file
1531         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1532   
1533         # check for corrupted VOB start
1534         check_vob_for_corrupted_start
1535  
1536         # check to make sure our VOB is complete
1537         check_vob_for_completeness
1538
1539         # check to make sure our VOB doesn't have too many video packets
1540         check_vob_for_too_many_video_packets
1541
1542         # check to make sure our VOB doesn't have a52 crc errors
1543         check_vob_for_a52_crc_errors
1544
1545         # remove the intermediate VOB file
1546         remove_intermediate_vob_file
1547
1548       fi
1549
1550       # remove the intermediate ISO file
1551       remove_intermediate_iso_file
1552
1553     else
1554       if [ "$encoder" != "handbrake" ]; then 
1555         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1556         # get our audio id from the VOB file
1557         get_audio_id_from_vob "$vobfile"
1558         # get the crop value from the VOB
1559         get_crop_from_vob
1560       fi
1561     fi
1562
1563     # eject the DVD disk since we are finished with it
1564     [ $eject_disk -eq 2 ] && eject -T $dev
1565
1566     # encode the VOB file to a compressed file format
1567     if [ $make_final_dest_comp -eq 1 ]; then
1568       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1569
1570       # determine what our bitrate needs to be if a target size was specified instead
1571       calculate_bitrate_from_target_size        
1572      
1573       # encode the vob file into a compressed file format
1574       if [[ "$encoder" == "mencoder" ]]; then 
1575         encode_vob_file_mencoder
1576       fi
1577       if [[ "$encoder" == "handbrake" ]]; then
1578         encode_vob_file_handbrake
1579       fi
1580
1581       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1582         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1583         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1584       else
1585         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1586         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1587       fi
1588     fi
1589
1590   # add this video data to the mythtv DB
1591   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1592   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1593     
1594   else
1595
1596   # use dvdbackup to make a DVD folder of the feature title
1597   make_dvdbackup_folder_image
1598
1599   # cd to the feature title DVD folder
1600   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1601   if [ $? != 0 ]; then
1602     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1603   fi
1604   
1605   # create the dvd.xml file for dvdauthor
1606   create_dvdauthor_dvd_xml_file  
1607
1608   # make the final DVD folder image
1609   make_dvdauthor_folder_image
1610
1611   # add this video data to the mythtv DB
1612   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1613  
1614   # cd back to the dir we started from
1615   popd > /dev/null 2>&1
1616
1617   if [ $make_final_dest_iso -eq 1 ]; then
1618
1619     # make an iso image out of our directory
1620     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1621    
1622     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1623     if [ -s "$dest/$dvdname.iso" ]; then
1624       if [ $make_final_dest_folder -eq 0 ]; then
1625         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1626         # remove the folder of the DVD image now that we have a .iso version of it
1627         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1628       fi
1629     else
1630       # we created an empty iso file, remove it
1631       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1632       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1633       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1634     fi
1635  
1636     # add this video data to the mythtv DB
1637     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1638
1639   fi
1640
1641   fi
1642
1643   # remove the ddrescue DVD ISO image
1644   remove_intermediate_iso_file
1645
1646   # remove the tmp dvdbackup folder of the DVD image
1647   remove_intermediate_dvdbackup_folder
1648
1649   # eject the DVD disk upon completion
1650   [ $eject_disk -eq 1 ] && eject -T $dev
1651
1652   date=`date`
1653   echo "$date DVD rip completed" | tee -a "$logfile"
1654
1655   if [[ -n "$mailto" ]]; then
1656     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1657   fi
1658
1659 fi
1660
1661 ##############################################################################################